Skip to main content
POST
Update access type

Authorizations

Authorization
string
header
required

Bearer authentication header of the form Bearer <token>, where <token> is your auth token.

Body

application/json
bucket_name
string
required

Full name of the bucket that should be affected.

Example:

"nio-yourcompany-iwhhrql8sgvp"

new_access
object
required
Example:

Response

200 - application/json

OK

An AWS S3 bucket created inside Narrative's AWS account assigned to a specific company.

id
string<uuid>
required

Unique identifier for the bucket.

Example:

"4d5451ff-5fe6-4db3-9398-4075bbd275b0"

auth
object
required

How your AWS account reaches the bucket. type is bucket_policy, role or user.

company_id
integer
required

The ID of the company owning the bucket.

name
string
required

The AWS S3 bucket name. The bucket name is of the form nio-${resource_id}-${suffix} where resource_id is the resource ID provided at bucket creation and suffix is 12 randomly chosen alphanumeric characters.

A random suffix is appended to the bucket name for two reasons:

  • AWS S3 bucket names must be globally unique, i.e. the bucket namespace is shared by all AWS accounts. Appending a random suffix helps ensure that we can create a bucket which includes your preferred resource ID.
  • Another consequence of AWS S3 bucket names needing to be globally unique is that anyone can easily check if a bucket with a given name exists. By appending a random suffix to your bucket we are preventing information leakage by making it impractical for an attacker to determine whether you are a customer of Narrative by simply guessing your resource ID and checking whether a bucket with the name nio-${resource_id} exists.
Example:

"nio-yourcompanyname-50ac58dabfa1"

created_at
string<date-time>
required

When the bucket was created.

Example:

"2021-08-26T21:06:07.710357Z"

updated_at
string<date-time>
required

When the bucket was last updated.

Example:

"2021-08-26T21:06:07.710357Z"

is_access_mutable
boolean
required

Whether POST /resources/update-access can change the bucket's access type. Buckets created through POST /resources/buckets can be changed. Some buckets created before 2023 with custom policies cannot.